using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace patterns
{
    class Resource : IDisposable
    {
        public void op()
        {
            Console.WriteLine("operation...");
        }

        ~Resource()
        {
            Cleanup();
        }

        public void Dispose()
        {
            Cleanup();
            GC.SuppressFinalize(this);
        }

        private void Cleanup()
        {
            Console.WriteLine("cleanup expensive resource");
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            using(Resource resource = new Resource()) {
                resource.op();
            }
            //Requires discipline on the part of the programmer
            //to use using. If they don't, resource deallocation may
            //get delayed and that may lead to problems.
        }
    }
}
