using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace patterns
{
    class Program
    {
        static int totalSelectedValues(int[] values,
            Func<int, bool> selector)
        {
            int total = 0;
            foreach(int value in values)
            {
                if (selector(value)) total += value;
            }

            return total;
        }

        static void Main(string[] args)
        {
            int[] values = new int[] {1, 2, 3, 4, 5, 6};

            Console.WriteLine(totalSelectedValues(values, (value) => true));
            Console.WriteLine(totalSelectedValues(values, (value) => value % 2 == 0));
            Console.WriteLine(totalSelectedValues(values, (value) => value % 2 != 0));
            Console.WriteLine(totalSelectedValues(values, (value) => value > 4));
        }
    }
}
